
clear;
%% script ver9

%% set rng seed value

rng(11)


%% read from table
%use enumerated data to represent placetype

%1 : Har behov for fast arbeidsplass, med PC og skjerm
%2 : Har behov for fast arbeidsplass, med skjerm
%3 : Har behov for fast arbeidsplass, uten PC-utstyr
%4 : Har kun behov for "drop-in"-arbeidsplass
%5 : Har ikke behov for arbeidsplass på instituttet

%legge til flere kolonner
%% input 1
%choose which arbeidsplass table to read from
arbeidsplasser = readtable('Arbeidsplasserharderdata1.xlsx');

temp1 = table('Size',[height(arbeidsplasser) 2],'VariableTypes',{'logical', 'uint8'}, 'VariableNames',  {'allocatedtruefalse', 'countroom'});
arbeidsplasser = [arbeidsplasser temp1];

arbeidsplasser.ROM = categorical(arbeidsplasser.ROM);

arbeidsplass_categories = categories(arbeidsplasser.ROM);

%legge til flere kolonner

%% input 2
%choose which soeknader table to read from
soknader = readtable('Soknaderharderdata1.xlsx', 'ReadRowNames',true);
temp2 = table('Size',[height(soknader) 8],'VariableTypes',{'string', 'string', 'uint8', 'logical', 'logical', 'logical', 'uint8', 'uint8'}, 'VariableNames',  {'allocatedroomname','allocatedplacenumber','allocatedplacetype', 'lucky1', 'lucky2', 'lucky3', 'newplacetypetoallocate', 'countoccurence'});
outputtable = [soknader temp2];

outputtable = sortrows(outputtable,1);


%convert column faglaerer to categorical datatype for easier comparison
%between values later
outputtable.Faglaerer = categorical(outputtable.Faglaerer);
Faglaerer_categories = categories(outputtable.Faglaerer);

outputtable.allocatedroomname = categorical(outputtable.allocatedroomname,arbeidsplass_categories);

%% Tildele ønsked plasstype for de som har søkt om drop in og ikke behov
% siden det ikke er noe begrensninger på tildeling for de type plassene

%4 : Har kun behov for "drop-in"-arbeidsplass
%5 : Har ikke behov for arbeidsplass på instituttet
for index = 1:height(outputtable)
    if outputtable{index,1} == 4
        outputtable{index,6} = outputtable{index,1};
    elseif outputtable{index,1} == 5
        outputtable{index,6} = outputtable{index,1};
    end
end

%% Compute some numbers to use for control flow
%compute number of each type of workplace

num_of_workplace1 = 0;
num_of_workplace2 = 0;
num_of_workplace3 = 0;
for index = 1:height(arbeidsplasser)
    if arbeidsplasser{index,3} == 1
        num_of_workplace1 = num_of_workplace1 + 1;
    elseif arbeidsplasser{index,3} == 2
        num_of_workplace2 = num_of_workplace2 + 1;
    elseif arbeidsplasser{index,3} == 3
        num_of_workplace3 = num_of_workplace3 + 1;
    end
end

%find number of students that want each type
studentwantsworkplace1 = 0;
studentwantsworkplace2 = 0;
studentwantsworkplace3 = 0;
for index = 1:height(outputtable)
    if outputtable{index,1} == 1
        studentwantsworkplace1 = studentwantsworkplace1 + 1;
    elseif outputtable{index,1} == 2
        studentwantsworkplace2 = studentwantsworkplace2 + 1;
    elseif outputtable{index,1} == 3
        studentwantsworkplace3 = studentwantsworkplace3 + 1;
    end
end


%% choose lucky people to optimize

%preallocate some values
for i = 1:height(outputtable)
    outputtable{i, 10} =  outputtable{i, 1};
end


%må velge unike verdier bare 1 gang når man velger "lucky" folk
%https://se.mathworks.com/matlabcentral/answers/296686-randomly-select-different-elements-of-a-vector



%indices for those with origbehovforarbeidsplass == 1
index_orig_1 = find(outputtable{:,1}==1);


%select who to be lucky
for i = 1:num_of_workplace1
    ind = randperm(numel(index_orig_1), 1); % select one element out of numel(x) elements, with the probability of occurrence of the element in x
    luckypeople_1(i) = index_orig_1(ind);
    index_orig_1(index_orig_1==luckypeople_1(i)) = []; % delete this element from the sample, such that the picked elements are unique
end


%insert values into table for later functions to use
for index = luckypeople_1
    outputtable{index, 7} = 1;
end

%insert values into table for later functions to use
for index = 1:height(outputtable)
    if outputtable{index, 10} == 1 && outputtable{index, 7} ~= 1
        outputtable{index, 10} = 2;
    end
end

%% now for workplace_2

%indices for those with origbehovforarbeidsplass == 2
index_orig_2 = find(outputtable{:,10}==2);

% add duplicates to increase prob of those who should have higher prob
temparray2 = find(outputtable{:,10}==2 & outputtable{:,1}==2);

%select how many times
increaseprob1 = 2;
for i = 1:increaseprob1
    index_orig_2 = cat(1,index_orig_2,temparray2);
end

%select who to be lucky
for i = 1:num_of_workplace2
    ind = randperm(numel(index_orig_2), 1); % select one element out of numel(x) elements, with the probability of occurrence of the element in x
    luckypeople_2(i) = index_orig_2(ind);
    index_orig_2(index_orig_2==luckypeople_2(i)) = []; % delete this element from the sample, such that the picked elements are unique
end

%insert values into table for later functions to use
for index = luckypeople_2
    outputtable{index, 8} = 1;
end

%insert values into table for later functions to use
for index = 1:height(outputtable)
    if outputtable{index, 10} == 2 && outputtable{index, 8} ~= 1
        outputtable{index, 10} = 3;
    end
end

%% now for workplace_3
%indices for those with origbehovforarbeidsplass == 3
index_orig_3 = find(outputtable{:,10}==3);


% add duplicates to increase prob of those who should have higher prob
temparray3 = find(outputtable{:,10}==3 & outputtable{:,1}==3);

%select how many times
increaseprob2 = 2;
for i = 1:increaseprob2
    index_orig_3 = cat(1,index_orig_3,temparray3);
end

%select who to be lucky
for i = 1:num_of_workplace3
    ind = randperm(numel(index_orig_3), 1); % select one element out of numel(x) elements, with the probability of occurrence of the element in x
    luckypeople_3(i) = index_orig_3(ind);
    index_orig_3(index_orig_3==luckypeople_3(i)) = []; % delete this element from the sample, such that the picked elements are unique
end

%insert values into table for later functions to use
for index = luckypeople_3
    outputtable{index, 9} = 1;
end

%insert values into table for later functions to use
for index = 1:height(outputtable)
    if outputtable{index, 10} == 3 && outputtable{index, 9} ~= 1
        outputtable{index, 10} = 4;
        outputtable{index, 6} = 4;
    end
end

%% compute room with most places and veilere with most students

%% add numbers to extra columns in table
exp11 = (arbeidsplasser.TypeArbeidsplass == 1);
arbeidsplasser1 = arbeidsplasser.ROM(exp11,:);
categories(arbeidsplasser1);
count_arbeidsplass1 = countcats(arbeidsplasser1);
testtable11 = table(count_arbeidsplass1);
testtable11.Properties.RowNames = arbeidsplass_categories;

exp12 = (outputtable.(10) == 1);
outputtableFaglaerer1 = outputtable.Faglaerer(exp12,:);
categories(outputtableFaglaerer1);
count_Faglaerer1 = countcats(outputtableFaglaerer1);
testtable12 = table(count_Faglaerer1);
testtable12.Properties.RowNames = Faglaerer_categories;

exp21 = (arbeidsplasser.TypeArbeidsplass == 2);
arbeidsplasser2 = arbeidsplasser.ROM(exp21,:);
categories(arbeidsplasser2);
count_arbeidsplass2 = countcats(arbeidsplasser2);
testtable21 = table(count_arbeidsplass2);
testtable21.Properties.RowNames = arbeidsplass_categories;

exp22 = (outputtable.(10) == 2);
outputtableFaglaerer2 = outputtable.Faglaerer(exp22,:);
categories(outputtableFaglaerer2);
count_Faglaerer2 = countcats(outputtableFaglaerer2);
testtable22 = table(count_Faglaerer2);
testtable22.Properties.RowNames = Faglaerer_categories;

exp31 = (arbeidsplasser.TypeArbeidsplass == 3);
arbeidsplasser3 = arbeidsplasser.ROM(exp31,:);
categories(arbeidsplasser3);
count_arbeidsplass3 = countcats(arbeidsplasser3);
testtable31 = table(count_arbeidsplass3);
testtable31.Properties.RowNames = arbeidsplass_categories;

exp32 = (outputtable.(10) == 3);
outputtableFaglaerer3 = outputtable.Faglaerer(exp32,:);
categories(outputtableFaglaerer3);
count_Faglaerer3 = countcats(outputtableFaglaerer3);
testtable32 = table(count_Faglaerer3);
testtable32.Properties.RowNames = Faglaerer_categories;

% add to arbeidsplasser
for index = 1:height(arbeidsplasser)
    switch arbeidsplasser{index,3}
        case 1
            arbeidsplasser{index,5} = testtable11{cellstr(arbeidsplasser{index,1}), 1};
        case 2
            arbeidsplasser{index,5} = testtable21{cellstr(arbeidsplasser{index,1}), 1};
        case 3
            arbeidsplasser{index,5} = testtable31{cellstr(arbeidsplasser{index,1}), 1};
    end
end

%add to outputtable
for index = 1:height(outputtable)
    switch outputtable{index,10}
        case 1
            outputtable{index,11} = testtable12{cellstr(outputtable{index,3}), 1};
        case 2
            outputtable{index,11} = testtable22{cellstr(outputtable{index,3}), 1};
        case 3
            outputtable{index,11} = testtable32{cellstr(outputtable{index,3}), 1};
    end
end

%%sort based on number of occurenses of room size and faglaerer

arbeidsplasser = sortrows(arbeidsplasser,[3 5],{'ascend' 'descend'});

outputtable = sortrows(outputtable,[10 11],{'ascend' 'descend'});



%% preassign workplaces
% assign workplace 1

for index = 1:height(outputtable)
    if outputtable{index, 10} == 1
        for index2 = 1:height(arbeidsplasser)
            if arbeidsplasser{index2, 3} == 1
                if (outputtable{index,6} == 0) && (arbeidsplasser{index2, 4} == 0)
                    outputtable(index,4:6) = arbeidsplasser(index2, 1:3);
                    arbeidsplasser{index2, 4} = 1;
                end
            end
        end
    end
end

% assign workplace 2

for index = 1:height(outputtable)
    if outputtable{index, 10} == 2
        for index2 = 1:height(arbeidsplasser)
            if arbeidsplasser{index2, 3} == 2
                if (outputtable{index,6} == 0) && (arbeidsplasser{index2, 4} == 0)
                    outputtable(index,4:6) = arbeidsplasser(index2, 1:3);
                    arbeidsplasser{index2, 4} = 1;
                end
            end
        end
    end
end

% assign workplace 3

for index = 1:height(outputtable)
    if outputtable{index, 10} == 3
        for index2 = 1:height(arbeidsplasser)
            if arbeidsplasser{index2, 3} == 3
                if (outputtable{index,6} == 0) && (arbeidsplasser{index2, 4} == 0)
                    outputtable(index,4:6) = arbeidsplasser(index2, 1:3);
                    arbeidsplasser{index2, 4} = 1;
                end
            end
        end
    end
end


%% inner optimize
% 
% tic
% computecost(outputtable)
% toc

Sol_Best = outputtable;

Candidate_best = outputtable; % zeros(size(Sol_0));

iterations = 1;

%plotting data
% cost_vector = computecost(Candidate_best);
% 
% [constraint1(2), constraint2(2), constraint3(2)] = computenumber(Candidate_best);


%while ~(stoppingCondition()) %maybe something like Sol_Best == Candidate_best;
% temp1 = getrowcost(outputtable);
% rowstooptimize = find(temp1);

loopssinceimprovement = 0;
mostcostindex = 1;

%% variables for plotting
cost_vector(1) = computecost(Sol_Best);

[constraint1(1), constraint2(1), constraint3(1)] = computenumber(Sol_Best);


%% optimisation loop
disp('beginning optimisation loop');
while loopssinceimprovement < 10 && iterations < 40
    
    
    
    temp1 = getrowcost(Sol_Best);
    [temp1sorted , sortindex] = sort(temp1, 'descend');
    
    
%     mostcostindex = 1;
%     values = getrowmostcost(Sol_Best);
%     temp1 = getrowcost(Sol_Best);
%     [temp1sorted , sortindex] = sort(temp1, 'descend');
%     rowstooptimize = find(temp1);
    
%     temp3 = getrowcost(outputtable);
%     
%     if temp3 == 0
%         continue
%     end
    
    %while ((loopssinceimprovement <= 2)) %maybe something like Sol_Best == Candidate_best;

        Sol_neighbors = getneighborsof(Sol_Best,sortindex(mostcostindex)); % list of neighbors % find best way to get neighbors

        for i = 1:size(Sol_neighbors, 2)
            tempvalue1 = computecost(Candidate_best);
            if computecost(Sol_neighbors{i}) < tempvalue1
                Candidate_best = Sol_neighbors{i};
                tempvalue1 = computecost(Candidate_best);
            end
            
        end
        if computecost(Candidate_best) < computecost(Sol_Best)
            Sol_Best = Candidate_best;
            loopssinceimprovement = 0;
            disp('new Sol_Best');
            mostcostindex = 1;
        else
            disp('no new Sol_Best');
            mostcostindex = mostcostindex + 1;
            loopssinceimprovement = loopssinceimprovement + 1;
        end
%     
%     cost_vector(iterations) = computecost(Sol_Best);
% 
%     [constraint1(iterations), constraint2(iterations), constraint3(iterations)] = computenumber(Sol_Best);
    iterations = iterations + 1;
    cost_vector(iterations) = computecost(Sol_Best);
    [constraint1(iterations), constraint2(iterations), constraint3(iterations)] = computenumber(Sol_Best);


    %end
    
    
    disp('new outer loop');
    disp(iterations);
end

%%getneighborsof(). finne swaps med andre studenter som har samme emne, og
%%i tillegg returnere en subset av neighboors med studenter som bidrar til
%%objectfunksjonen


%% print to console for easier debugging

[outputcost1before, outputcost2before, outputcost3before] = computenumber(outputtable);

[outputcost1after, outputcost2after, outputcost3after] = computenumber(Sol_Best);

fprintf('cost of before table: %d \n', computecost(outputtable));
fprintf('Before: cost1: %d cost2: %d ;cost3: %d ; \n', outputcost1before, outputcost2before, outputcost3before);

fprintf('cost of after table: %d \n', computecost(Sol_Best));
fprintf('After: cost1: %d cost2: %d ;cost3: %d ; \n', outputcost1after, outputcost2after, outputcost3after);

fprintf('row with most cost in before table: %d \n', getrowmostcost(outputtable));

fprintf('row with most cost in after table: %d \n', getrowmostcost(Sol_Best));

fprintf('Finished \n')

%% code for plotting

figure
grid on
subplot(2,1,1)
grid on
plot(cost_vector)
title('Value of Objective Function')
legend('Total cost')
xlabel('iterations')
ylabel('Value')

subplot(2,1,2)
grid on
hold on
plot(constraint1)
plot(constraint2)
plot(constraint3)
hold off
title('cost from each term')
legend('cost_1', 'cost_2', 'cost_3')
xlabel('iterations')
ylabel('occurrences')






