
clear;

%% script ver4

%todo
%add funk for when students exceed workplace
%add funk for when workplace exceed students

%vil sitte med studenter med samme behov for arbeidsplass

%% read from table
%use enumerated data to represent placetype

%1 : Har behov for fast arbeidsplass, med PC og skjerm
%2 : Har behov for fast arbeidsplass, med skjerm
%3 : Har behov for fast arbeidsplass, uten PC-utstyr
%4 : Har kun behov for "drop-in"-arbeidsplass
%5 : Har ikke behov for arbeidsplass på instituttet

%legge til flere kolonner
arbeidsplasser = readtable('AlleArbeidsplasser3.xlsx');
temp1 = table('Size',[height(arbeidsplasser) 1],'VariableTypes',{'logical'}, 'VariableNames',  {'allocatedtruefalse'});
arbeidsplasser = [arbeidsplasser temp1];

%legge til flere kolonner
soknader = readtable('Soknader4.xlsx', 'ReadRowNames',true);
temp2 = table('Size',[height(soknader) 6],'VariableTypes',{'string', 'string', 'uint8', 'logical', 'logical', 'logical'}, 'VariableNames',  {'allocatedroomname','allocatedplacenumber','allocatedplacetype', 'priority', 'optimize1', 'optimize2'});
outputtable = [soknader temp2];

outputtable = sortrows(outputtable,1);

%% Tildele ønsked plasstype for de som har søkt om drop in og ikke behov
% siden det ikke er noe begrensninger på tildeling for de type plassene

%4 : Har kun behov for "drop-in"-arbeidsplass
%5 : Har ikke behov for arbeidsplass på instituttet
for index = 1:height(outputtable)
    if outputtable{index,1} == 4
        outputtable{index,5} = outputtable{index,1};
    elseif outputtable{index,1} == 5
        outputtable{index,5} = outputtable{index,1};
    end
end


%% Compute some numbers to use for control flow
%compute number of each type of workplace

num_of_workplace1 = 0;
num_of_workplace2 = 0;
num_of_workplace3 = 0;
for index = 1:height(arbeidsplasser)
    if arbeidsplasser{index,3} == 1
        num_of_workplace1 = num_of_workplace1 + 1;
    elseif arbeidsplasser{index,3} == 2
        num_of_workplace2 = num_of_workplace2 + 1;
    elseif arbeidsplasser{index,3} == 3
        num_of_workplace3 = num_of_workplace3 + 1;
    end
end

%find number of students that want each type
studentwantsworkplace1 = 0;
studentwantsworkplace2 = 0;
studentwantsworkplace3 = 0;
for index = 1:height(outputtable)
    if outputtable{index,1} == 1
        studentwantsworkplace1 = studentwantsworkplace1 + 1;
    elseif outputtable{index,1} == 2
        studentwantsworkplace2 = studentwantsworkplace2 + 1;
    elseif outputtable{index,1} == 3
        studentwantsworkplace3 = studentwantsworkplace3 + 1;
    end
end

%% dumb preassign workplaces
% assign workplace 1

for index = 1:height(outputtable)
    if outputtable{index, 1} == 1
        for index2 = 1:height(arbeidsplasser)
            if arbeidsplasser{index2, 3} == 1
                if (outputtable{index,5} == 0) && (arbeidsplasser{index2, 4} == 0)
                    outputtable(index,3:5) = arbeidsplasser(index2, 1:3);
                    arbeidsplasser{index2, 4} = 1;
                end
            end
        end
    end
end

% assign workplace 2

for index = 1:height(outputtable)
    if outputtable{index, 1} == 2
        for index2 = 1:height(arbeidsplasser)
            if arbeidsplasser{index2, 3} == 2
                if (outputtable{index,5} == 0) && (arbeidsplasser{index2, 4} == 0)
                    outputtable(index,3:5) = arbeidsplasser(index2, 1:3);
                    arbeidsplasser{index2, 4} = 1;
                end
            end
        end
    end
end

% assign workplace 3

for index = 1:height(outputtable)
    if outputtable{index, 1} == 3
        for index2 = 1:height(arbeidsplasser)
            if arbeidsplasser{index2, 3} == 3
                if (outputtable{index,5} == 0) && (arbeidsplasser{index2, 4} == 0)
                    outputtable(index,3:5) = arbeidsplasser(index2, 1:3);
                    arbeidsplasser{index2, 4} = 1;
                end
            end
        end
    end
end

%%choose lucky people to optimize

%table need to be sorted on workplacetype for this implemetation to work
%correctly, outputtable = sortrows(outputtable,1);
priority_stud_1 = randperm(num_of_workplace1,studentwantsworkplace1);

priority_stud_2 = studentwantsworkplace1 + randperm(num_of_workplace2,studentwantsworkplace2);

priority_stud_3 = studentwantsworkplace1 + studentwantsworkplace2 + randperm(num_of_workplace3,studentwantsworkplace3);

for index = priority_stud_1
    outputtable{index, 6} = 1;
end

for index = priority_stud_2
    outputtable{index, 7} = 1;
end

for index = priority_stud_3
    outputtable{index, 8} = 1;
end

%% inner optimize


computecost(outputtable)
Sol_Best = outputtable;

Candidate_best = outputtable; % zeros(size(Sol_0));

iterations = 1;
loopssinceimprovement = 0;

%plotting data
% cost_vector = computecost(Candidate_best);
% 
% [constraint1(2), constraint2(2), constraint3(2)] = computenumber(Candidate_best);


%while ~(stoppingCondition()) %maybe something like Sol_Best == Candidate_best;
while ((loopssinceimprovement < 2) && (computecost(Sol_Best) ~= 0)) %maybe something like Sol_Best == Candidate_best;
    Sol_neighbors = getneighborsof(Candidate_best); % list of neighbors % find best way to get neighbors
    
    for i = 1:size(Sol_neighbors, 2)
        if computecost(Sol_neighbors{i}) < computecost(Candidate_best)
            Candidate_best = Sol_neighbors{i};
        end
    end
    
    if computecost(Candidate_best) < computecost(Sol_Best)
        Sol_Best = Candidate_best;
        loopssinceimprovement = 0;
    end
%     
%     cost_vector(iterations) = computecost(Sol_Best);
% 
%     [constraint1(iterations), constraint2(iterations), constraint3(iterations)] = computenumber(Sol_Best);

    iterations = iterations + 1;
    loopssinceimprovement = loopssinceimprovement + 1;
end

%%getneighborsof(). finne swaps med andre studenter som har samme emne, og
%%i tillegg returnere en subset av neighboors med studenter som bidrar til
%%objectfunksjonen


computecost(Sol_Best)
computecost(outputtable)
disp('Finished')





