
clear;

%% script ver4

%todo
%add funk for when students exceed workplace
%add funk for when workplace exceed students

%vil sitte med studenter med samme behov for arbeidsplass

%% read from table
%use enumerated data to represent placetype

%1 : Har behov for fast arbeidsplass, med PC og skjerm
%2 : Har behov for fast arbeidsplass, med skjerm
%3 : Har behov for fast arbeidsplass, uten PC-utstyr
%4 : Har kun behov for "drop-in"-arbeidsplass
%5 : Har ikke behov for arbeidsplass på instituttet

%legge til flere kolonner
arbeidsplasser = readtable('AlleArbeidsplasser3.xlsx');
temp1 = table('Size',[height(arbeidsplasser) 1],'VariableTypes',{'logical'}, 'VariableNames',  {'allocatedtruefalse'});
arbeidsplasser = [arbeidsplasser temp1];

%legge til flere kolonner
soknader = readtable('Soknader5.xlsx', 'ReadRowNames',true);
temp2 = table('Size',[height(soknader) 7],'VariableTypes',{'string', 'string', 'uint8', 'logical', 'logical', 'logical', 'uint8'}, 'VariableNames',  {'allocatedroomname','allocatedplacenumber','allocatedplacetype', 'lucky1', 'lucky2', 'lucky3', 'newplacetypetoallocate'});
outputtable = [soknader temp2];

outputtable = sortrows(outputtable,1);

%% Tildele ønsked plasstype for de som har søkt om drop in og ikke behov
% siden det ikke er noe begrensninger på tildeling for de type plassene

%4 : Har kun behov for "drop-in"-arbeidsplass
%5 : Har ikke behov for arbeidsplass på instituttet
for index = 1:height(outputtable)
    if outputtable{index,1} == 4
        outputtable{index,5} = outputtable{index,1};
    elseif outputtable{index,1} == 5
        outputtable{index,5} = outputtable{index,1};
    end
end


%% Compute some numbers to use for control flow
%compute number of each type of workplace

num_of_workplace1 = 0;
num_of_workplace2 = 0;
num_of_workplace3 = 0;
for index = 1:height(arbeidsplasser)
    if arbeidsplasser{index,3} == 1
        num_of_workplace1 = num_of_workplace1 + 1;
    elseif arbeidsplasser{index,3} == 2
        num_of_workplace2 = num_of_workplace2 + 1;
    elseif arbeidsplasser{index,3} == 3
        num_of_workplace3 = num_of_workplace3 + 1;
    end
end

%find number of students that want each type
studentwantsworkplace1 = 0;
studentwantsworkplace2 = 0;
studentwantsworkplace3 = 0;
for index = 1:height(outputtable)
    if outputtable{index,1} == 1
        studentwantsworkplace1 = studentwantsworkplace1 + 1;
    elseif outputtable{index,1} == 2
        studentwantsworkplace2 = studentwantsworkplace2 + 1;
    elseif outputtable{index,1} == 3
        studentwantsworkplace3 = studentwantsworkplace3 + 1;
    end
end


%% choose lucky people to optimize

%preallocate some values that some of will get written over later
for i = 1:height(outputtable)
    outputtable{i, 9} =  outputtable{i, 1};
end

%skrive om hvordan man velger riktig i rapporten
%må velge unike verdier bare 1 gang når man velger "lucky" folk
%https://se.mathworks.com/matlabcentral/answers/296686-randomly-select-different-elements-of-a-vector



%indices for those with origbehovforarbeidsplass == 1
index_orig_1 = find(outputtable{:,1}==1);

%TODO: add option to increase prob of those lucky


%select who to be lucky
for i = 1:num_of_workplace1
    ind = randperm(numel(index_orig_1), 1); % select one element out of numel(x) elements, with the probability of occurrence of the element in x
    luckypeople_1(i) = index_orig_1(ind);
    index_orig_1(index_orig_1==luckypeople_1(i)) = []; % delete this element from the sample, such that the picked elements are unique
end


%insert values into table for later functions to use
for index = luckypeople_1
    outputtable{index, 6} = 1;
end

%insert values into table for later functions to use
for index = 1:height(outputtable)
    if outputtable{index, 9} == 1 && outputtable{index, 6} ~= 1
        outputtable{index, 9} = 2;
    end
end

%% now for workplace_2

%indices for those with origbehovforarbeidsplass == 2
index_orig_2 = find(outputtable{:,9}==2);

% add duplicates to increase prob of those who should have higher prob
%do this multiple times
temparray2 = find(outputtable{:,9}==2 & outputtable{:,1}==2);

%select how many times
increaseprob1 = 2;
for i = 1:increaseprob1
    index_orig_2 = cat(1,index_orig_2,temparray2);
end

%select who to be lucky
for i = 1:num_of_workplace2
    ind = randperm(numel(index_orig_2), 1); % select one element out of numel(x) elements, with the probability of occurrence of the element in x
    luckypeople_2(i) = index_orig_2(ind);
    index_orig_2(index_orig_2==luckypeople_2(i)) = []; % delete this element from the sample, such that the picked elements are unique
end

%insert values into table for later functions to use
for index = luckypeople_2
    outputtable{index, 7} = 1;
end

%insert values into table for later functions to use
for index = 1:height(outputtable)
    if outputtable{index, 9} == 2 && outputtable{index, 7} ~= 1
        outputtable{index, 9} = 3;
    end
end

%% now for workplace_3
%indices for those with origbehovforarbeidsplass == 3
index_orig_3 = find(outputtable{:,9}==3);


% add duplicates to increase prob of those who should have higher prob
%do this multiple times
temparray3 = find(outputtable{:,9}==3 & outputtable{:,1}==3);

%select how many times
increaseprob2 = 2;
for i = 1:increaseprob2
    index_orig_3 = cat(1,index_orig_3,temparray3);
end

%select who to be lucky
for i = 1:num_of_workplace3
    ind = randperm(numel(index_orig_3), 1); % select one element out of numel(x) elements, with the probability of occurrence of the element in x
    luckypeople_3(i) = index_orig_3(ind);
    index_orig_3(index_orig_3==luckypeople_3(i)) = []; % delete this element from the sample, such that the picked elements are unique
end

%insert values into table for later functions to use
for index = luckypeople_3
    outputtable{index, 8} = 1;
end

%insert values into table for later functions to use
for index = 1:height(outputtable)
    if outputtable{index, 9} == 3 && outputtable{index, 8} ~= 1
        outputtable{index, 9} = 4;
    end
end

%% dumb preassign workplaces
%this needs to change to use lucky people
% assign workplace 1

for index = 1:height(outputtable)
    if outputtable{index, 9} == 1
        for index2 = 1:height(arbeidsplasser)
            if arbeidsplasser{index2, 3} == 1
                if (outputtable{index,5} == 0) && (arbeidsplasser{index2, 4} == 0)
                    outputtable(index,3:5) = arbeidsplasser(index2, 1:3);
                    arbeidsplasser{index2, 4} = 1;
                end
            end
        end
    end
end

% assign workplace 2

for index = 1:height(outputtable)
    if outputtable{index, 9} == 2
        for index2 = 1:height(arbeidsplasser)
            if arbeidsplasser{index2, 3} == 2
                if (outputtable{index,5} == 0) && (arbeidsplasser{index2, 4} == 0)
                    outputtable(index,3:5) = arbeidsplasser(index2, 1:3);
                    arbeidsplasser{index2, 4} = 1;
                end
            end
        end
    end
end

% assign workplace 3

for index = 1:height(outputtable)
    if outputtable{index, 9} == 3
        for index2 = 1:height(arbeidsplasser)
            if arbeidsplasser{index2, 3} == 3
                if (outputtable{index,5} == 0) && (arbeidsplasser{index2, 4} == 0)
                    outputtable(index,3:5) = arbeidsplasser(index2, 1:3);
                    arbeidsplasser{index2, 4} = 1;
                end
            end
        end
    end
end


%% inner optimize


computecost(outputtable)
Sol_Best = outputtable;

Candidate_best = outputtable; % zeros(size(Sol_0));

iterations = 1;

%plotting data
% cost_vector = computecost(Candidate_best);
% 
% [constraint1(2), constraint2(2), constraint3(2)] = computenumber(Candidate_best);


%while ~(stoppingCondition()) %maybe something like Sol_Best == Candidate_best;
temp1=getrowcost(outputtable);
rowstooptimize = find(temp1);

for values = rowstooptimize
    
    loopssinceimprovement = 0;
    while ((loopssinceimprovement <= 2) && (computecost(Sol_Best) ~= 0)) %maybe something like Sol_Best == Candidate_best;
    
        Sol_neighbors = getneighborsof(Candidate_best,values); % list of neighbors % find best way to get neighbors
    
        for i = 1:size(Sol_neighbors, 2)
            if computecost(Sol_neighbors{i}) < computecost(Candidate_best)
                Candidate_best = Sol_neighbors{i};
            end
        end

        if computecost(Candidate_best) < computecost(Sol_Best)
            Sol_Best = Candidate_best;
            loopssinceimprovement = 0;
        end
    
%     
%     cost_vector(iterations) = computecost(Sol_Best);
% 
%     [constraint1(iterations), constraint2(iterations), constraint3(iterations)] = computenumber(Sol_Best);
    iterations = iterations + 1;
    loopssinceimprovement = loopssinceimprovement + 1;
    end
    
end

%%getneighborsof(). finne swaps med andre studenter som har samme emne, og
%%i tillegg returnere en subset av neighboors med studenter som bidrar til
%%objectfunksjonen


%%

%TODO:assign those who didnt get any designated places to drop in palces


computecost(outputtable)

computecost(Sol_Best)

getrowmostcost(Sol_Best)
disp('Finished')





